//+-------------------------------------------------------------------+
//|                                              Tick-Tack-toe_v1.mq4 |
//|                                 Copyright  2009, GoldenFox corp. |
//|                                                                   |
//|                      "-"                      |
//|                                                                   |
//|                                                                   |
//|       Period_Converter.mq4 |
//|    http://mql4.com/ru/                           |
//|                                                                   |
//|          , |
//|        ""  - |
//|   "    DLL",      |
//| "  ".      "  " |
//|        "".    |
//|                                                                   |
//|  :                                                |
//|   Kletka   -                                  |
//|   Razvorot - - ,               |
//|                                                                   |
//|          (      EUR/USD           |
//|              5-     )               |
//|                                                                   |
//|        ,  - |
//|        - |
//|   .   ""  " ", |
//|          |
//|  ( EURUSD,M2)     .   |
//|      " "            |
//|                                                                   |
//|         |
//|         - |
//|   "-" (       |
//|         ). |
//|      .                      |
//|                                                                   |
//|   ""    c     |
//| ,        .   |
//|                                                                   |
//|          |
//|     .       |
//|  .                                                        |
//|                                                                   |
//|       .             |
//|                                                                   |
//+-------------------------------------------------------------------+

#property copyright "Copyright  2009, GoldenFox Corp."
#property link      ""
#property show_inputs
#include <WinUser32.mqh>

static string s_ver="1.1";       // 

extern int     Kletka=50;        //   
extern int     RazvorotKletka=2; //-     ()

static int     Revers=0;      //-    ()
static int     ExtHandle=-1;  //    
static int     Kurs=0;        //       
static int     i_digits, i_time, i_open, i_low, i_high, i_close, i_last_close, last_fpos;
static double  d_point,d_volume;
static int     hwnd=0;
static int     ind_period=2;  //  
static int     i_period=0;    //    
static string  c_symbol;      //  
static bool    b_work=false;  //false -  ; true - 

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
//----  
   int    version=400;
   string c_copyright="(C)opyright 2003, MetaQuotes Software Corp.";
   c_symbol=Symbol();                           //  ()   
   int i_unused[13];                            //  
   i_digits=Digits;                             //-   
   d_point=NormalizeDouble(Point,i_digits+1);   // 
   i_period=Period()*60;                        //    
   Revers=Kletka*RazvorotKletka;                //  
  
//----  C    (   )
   ExtHandle=FileOpenHistory(c_symbol+ind_period+".hst", FILE_BIN|FILE_WRITE);//   
   if(ExtHandle < 0) return(-1);                                              //             
   //---------  
   FileWriteInteger(ExtHandle, version, LONG_VALUE);     // 4  
   FileWriteString(ExtHandle, c_copyright, 64);          //64  
   FileWriteString(ExtHandle, c_symbol, 12);             //12   
   FileWriteInteger(ExtHandle, ind_period, LONG_VALUE);  // 4   
   FileWriteInteger(ExtHandle, i_digits, LONG_VALUE);    // 4  -   
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);           // 4  timesign
   FileWriteInteger(ExtHandle, 0, LONG_VALUE);           // 4  last_sync
   FileWriteArray(ExtHandle, i_unused, 0, 13);           //52  
                                                 //  148  
   WriteHistory();  // .   
   Comment("\n - v",s_ver," . : ",Kletka,"p.  ", Revers, "p.",
           "\n   ",c_symbol,",M",ind_period,
           "\n( ->   -> ",c_symbol,",M",ind_period," -> )");
     
//----------------  
   while(IsStopped()==false) //     
     { 
      if(RefreshRates())         //    
        {
         Kurs=(NormalizeDouble(Bid, i_digits+1)/d_point)-MathMod(NormalizeDouble(Bid, i_digits+1)/d_point,Kletka);    //    
         CalculateBar();                                    //            
        } 
     } 
//--------------------------------------
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void CalculateBar() //    (  )
{ 
   if (i_open>i_last_close)      //      ,  .
     {            
      if (i_last_close>Kurs)        //     
        {                           //    .  
         i_time=TimeCurrent();         //        
         i_close=Kurs;                 //     
         i_low=i_close;                //     
         i_last_close=i_low;           //    
         WriteBar();                   //   
        } 
      else                          //    
        { 
         if (Kurs-i_last_close>Revers)   //          
           {                           //  (  )
            i_close=i_last_close;         //       
            WriteBar();                   //   
            i_open=i_last_close+Kletka;   //      
            i_low=i_open;                 //      
            i_close=Kurs;                 //                 
            i_high=i_close;               //      
            i_last_close=i_high;          //    
            i_time=TimeCurrent();         //        
            WriteNewBar();                //   
           } 
         else                          //   ,  
           {
            if (i_close!=Kurs)         //       
              {                        //      
               i_close=Kurs;              //            
               WriteBar();                //   
              }
           } 
        }             
     }
   else                            //       (.)
     {            
      if (i_last_close<Kurs)           //         
        {                              //    .  
         i_time=TimeCurrent();            //        
         i_close=Kurs;                    //                
         i_high=i_close;                  //            
         i_last_close=i_high;             //    
         WriteBar();                      //   
        } 
      else                             //     
         if (i_last_close-Kurs>Revers)      //          
           {                              //  (  )
            i_close=i_last_close;         //       
            WriteBar();                   //                         
            i_open=i_close-Kletka;        //      
            i_high=i_open;                //      
            i_close=Kurs;                 //     
            i_low=i_close;                //      
            i_last_close=i_low;           //    
            i_time=TimeCurrent();         //        
            WriteNewBar();                //                    
           }   
         else                          //   ,  
           {                           
            if (i_close!=Kurs)            //       
              {                           //      
               i_close=Kurs;              //     
               WriteBar();                //   
              }
           } 
     }
   return(0);
}
     
void WriteNewBar() //   
{ 
   FileSeek(ExtHandle, 0, SEEK_CUR); //   
   FileWriteInteger(ExtHandle, i_time, LONG_VALUE);            //4    
   FileWriteDouble(ExtHandle, i_open*d_point, DOUBLE_VALUE);   //8  
   FileWriteDouble(ExtHandle, i_low*d_point, DOUBLE_VALUE);    //8  
   FileWriteDouble(ExtHandle, i_high*d_point, DOUBLE_VALUE);   //8  
   FileWriteDouble(ExtHandle, i_close*d_point, DOUBLE_VALUE);  //8     
   FileWriteDouble(ExtHandle, i_high-i_low, DOUBLE_VALUE);     //8     
   FileFlush(ExtHandle);                     //   
   FileSeek(ExtHandle, 0, SEEK_CUR);         //   
   if (b_work)                               //   ,   
     {
      if(hwnd==0)hwnd=WindowHandle(Symbol(),ind_period);    //  
      if(hwnd!=0) PostMessageA(hwnd,WM_COMMAND,33324,0);    //  ,   
     }   
   return(0);
}
   
void WriteBar() //   
{
   FileSeek(ExtHandle, -44, SEEK_CUR); //    
   FileWriteInteger(ExtHandle, i_time, LONG_VALUE);            //4    
   FileWriteDouble(ExtHandle, i_open*d_point, DOUBLE_VALUE);   //8  
   FileWriteDouble(ExtHandle, i_low*d_point, DOUBLE_VALUE);    //8  
   FileWriteDouble(ExtHandle, i_high*d_point, DOUBLE_VALUE);   //8  
   FileWriteDouble(ExtHandle, i_close*d_point, DOUBLE_VALUE);  //8     
   FileWriteDouble(ExtHandle, i_high-i_low, DOUBLE_VALUE);     //8     
   FileFlush(ExtHandle);                                       //      
   FileSeek(ExtHandle, 0, SEEK_CUR);                           //   
   if (b_work)                                                 //   ,   
     {
      if(hwnd==0)hwnd=WindowHandle(Symbol(),ind_period);   //  
      if(hwnd!=0) PostMessageA(hwnd,WM_COMMAND,33324,0); //  ,   
     }   
   return(0);
}
  
int WriteHistory() //  
{ 
   b_work=false;                          //   ( )
   int i=0;                               //      
   int t=0;                               //     
   int l,h;                               //       
   i=Bars-2;                              //          
//----------------------   
   i_time=Time[i]+i_period;               //  
   i_low=NormalizeDouble(Low[i],i_digits+1)/d_point;   //   
   i_low=i_low-MathMod(i_low,Kletka);     //   
   i_high=NormalizeDouble(High[i],i_digits+1)/d_point; //   
   i_high=i_high-MathMod(i_high,Kletka);  //   
   if (Open[i]>Close[i])                  //       
     {                                    //  
      i_open=i_high;                         //       
      i_close=i_low;                         //       
     }
   else                                   //     
     {
      i_open=i_low;                          //       
      i_close=i_high;                        //       
     }  
   WriteBar();                            //  
//----------------------------------------------   
   
   for (i=i-1; i>=0; i--) // x     2- 
     { 
      if (i>0) i_time=Time[i]+i_period;   //   ,        
      else i_time=TimeCurrent();          //    
      if (i_open>i_close)        //    
        {
         l=NormalizeDouble(Low[i],i_digits+1)/d_point;  //      
         l=l-MathMod(l,Kletka);     //   
         if (l<i_close)             //       
           {                        //    .             
            i_close=l;                 //      
            i_low=l;                   //              
            WriteBar();                //  
           } 
         else                       //   
           {
            h=NormalizeDouble(High[i],i_digits+1)/d_point; //      
            h=h-MathMod(h,Kletka);     //      
            if (h-i_close>Revers)        //                            
              {                        //  
               i_open=i_close+Kletka;     //      
               i_low=i_open;              //        
               i_close=h;                 //        
               i_high=h;                  //        
               WriteNewBar();             //   
              } 
           }
        }
      else                       //    
        {
         h=NormalizeDouble(High[i],i_digits+1)/d_point;  //    
         h=h-MathMod(h,Kletka);     //     
         if (h>i_close)             //       
           {                        //    .             
            i_close=h;                 //      
            i_high=h;                  //      
            WriteBar();                //  
           }
         else                       //   
           {
            l=NormalizeDouble(Low[i],i_digits+1)/d_point;  //      
            l=l-MathMod(l,Kletka);     //    
            if (i_close-l>Revers)        //                             
              {                        //  
               i_open=i_close-Kletka;     //      
               i_high=i_open;             //        
               i_close=l;                 //        
               i_low=l;                   //        
               WriteNewBar();             //   
              } 
           }
        }   
 //----------  1000          
      t++;           //    
      if (t>1000)
        {
         t=0;
         if(hwnd==0)hwnd=WindowHandle(Symbol(),ind_period);   //  
         if(hwnd!=0) PostMessageA(hwnd,WM_COMMAND,33324,0); //  ,   
         Comment ("\n - v",s_ver," . : ",Kletka,"p.  ", Revers, "p.",
                     "\n   ",c_symbol,",M",ind_period,
                     "\n( ->   -> ",c_symbol,",M",ind_period," -> )",
                     "\n\n :  ",TimeToStr(i_time,TIME_DATE|TIME_MINUTES|TIME_SECONDS));         
        }
     }   
   i_last_close=i_close;   //     
   if(hwnd==0)hwnd=WindowHandle(Symbol(),ind_period);   //  
   if(hwnd!=0) PostMessageA(hwnd,WM_COMMAND,33324,0); //  ,   
   b_work=true;            //   (  : )
   return(0);
} 
      
void deinit() //  
{
   if(ExtHandle>=0) { FileClose(ExtHandle); ExtHandle=-1; } //    
   Comment("\n - v",s_ver," ");
}


